function IntegrationSafraPay(PaymentRepository, ScreenService, WindowService, templateManager){

    var self = this;
    var PAYMENT_CONFIRMATION = false;
    var REMOVE_ALL_INTEGRATIONS = false;
    var MESSAGE_INTEGRATION_FAIL = 'Não foi possível chamar a integração. Sua instância não existe.';

    var PAYMENTSTATUS_COMPLETED = '1';
    var PAYMENTSTATUS_REFUNDED  = '1';
    var PAYMENT_INVOICE = null;

    this.getPaymentInvoice = function(){
        var now = new Date();
        var year = now.getFullYear().toString();
        var month = self.leftZero(now.getMonth() + 1);
        var day = self.leftZero(now.getDate());
        var hour = self.leftZero(now.getHours());
        var minutes = self.leftZero(now.getMinutes());
        var seconds = self.leftZero(now.getSeconds());

        PAYMENT_INVOICE = year + month + day + hour + minutes + seconds;

        return PAYMENT_INVOICE;
    };

    this.integrationPayment = function(operatorData, currentRow){
        var params = {
            'paymentType': currentRow.tiporece.IDTIPORECE,
            'paymentValue': (currentRow.VRMOVIVEND.toFixed(2))*1000/10,//Favor não alterar, bug com 55 centavos
            'installmentsNumber': 0,
            'SafraPayId': self.getPaymentInvoice()
        };

        if(!!window.zhSafraPayAutomation) {
            window.changeLoader = self.changeLoader;
            zhSafraPayAutomation.initiateApp();
            zhSafraPayAutomation.continueApplication(JSON.stringify(params));
        } else {
            window.returnIntegration(self.invalidIntegrationInstance());
        }
    };

    this.leftZero = function(leftZero){
        if(leftZero < 10)
            leftZero = "0" + leftZero;

        return leftZero;
    };

    this.integrationPaymentResult = function(resolve, javaResult){
        var integrationResult = self.formatResponde();
        javaResult = self.handleJavaResult(javaResult);
        ScreenService.closePopup();
        if (javaResult.Status == 1){
                integrationResult.error = false;
                integrationResult.data = {
                    CDNSUHOSTTEF: javaResult.NsuTransacao,
                    TRANSACTIONID: javaResult.SafraPayId,
                    NRCONTROLTEF: javaResult.SafraPayId,
                    CDBANCARTCR: javaResult.Bandeira,
                    PAYMENTCONFIRMATION: PAYMENT_CONFIRMATION,
                    REMOVEALLINTEGRATIONS: REMOVE_ALL_INTEGRATIONS
                };
                ScreenService.restoreDefaultLoadingMessage();
                resolve(integrationResult);
        } else {
            integrationResult.message = javaResult.message||"Falha ao verificar retorno da transação";
            ScreenService.restoreDefaultLoadingMessage();
            resolve(integrationResult);
        }
    };

    this.changeLoader = function(action){
        if (action.message == "TRANSACTION_WAITING_CARD"){
            ScreenService.hideLoader();
            var widgetBase = templateManager.container.login || templateManager.containers.auth;
            var sitefWidget = widgetBase.getWidget("sitefPayment");
            var field = sitefWidget.getField("digitalWallets");
            sitefWidget.getField("userInput").isVisible = false;
            sitefWidget.getAction("btnBackStone").isVisible = false;
            sitefWidget.getAction("btnBackSmartA8").isVisible = true;
            sitefWidget.getAction("btnBack").isVisible = false;
            sitefWidget.getAction("btnBackADX8000").isVisible = false;
            sitefWidget.getAction("btnConfirmADX8000").isVisible = false;
            sitefWidget.getAction("btnConfirm").isVisible = false;
            field.isVisible = false;
            self.setLabel("SafraPay");

            ScreenService.openPopup(sitefWidget).then(function() {
                self.configureWindowFunctions();
                self.setMessage("Aproxime, insira ou passe o cartão");
            }.bind(this));

        } else if (action.message == "TRANSACTION_SENDING"){
            ScreenService.closePopup();
            ScreenService.changeLoadingMessage("Enviando Transação");
        } else if (action.message == "TRANSACTION_REMOVE_CARD"){
            ScreenService.closePopup();
            ScreenService.changeLoadingMessage("Retire o cartão");
        }
    };

    this.abortSmartA8Process = function(){
        zhSafraPayAutomation.abort();
    };

    this.setLabel = function(label) {
        var widgetBase = templateManager.container.login || templateManager.containers.auth;
        widgetBase.getWidget("sitefPayment").label = label;
    };

    this.setMessage = function(message) {
        var widgetBase = templateManager.container.login || templateManager.containers.auth;
        widgetBase.getWidget("sitefPayment").getField("userInterface").value(_.toUpper(message));
    };

    this.configureWindowFunctions = function() {
        window.hideLoader = ScreenService.hideLoader;
        window.showLoader = ScreenService.showLoader;
        window.setMessage = self.changeLoader;
        window.setLabel = self.setLabel;
        window.appendMessage = self.appendMessage;
        window.showConfigureEpayModule = self.showConfigureEpayModule;
        window.promptBoolean = self.promptBoolean;
        window.promptCommand = self.promptCommand;
        window.hideUserInterfaces = self.hideUserInterfaces;
        window.showCancelButton = self.showCancelButton;
        window.showQrCode = self.showQrCode;
        window.hideQrCode = self.hideQrCode;
        window.showMenuDigitalCard = self.showMenuDigitalCard;
    };

    // o cancelamento da SafraPay é o próprio estorno
    this.cancelIntegration = function(tiporeceData){
        self.reversalIntegration(tiporeceData);
    };

    this.cancelIntegrationResult = function(resolve, javaResult){
        self.reversalIntegrationResult(resolve, javaResult);
    };

    this.reversalIntegration = function(tiporeceData){
        if(!!window.zhSafraPayAutomation) {
            zhSafraPayAutomation.initiateApp();
            zhSafraPayAutomation.cancelaTransacao(tiporeceData.TRANSACTIONID, (tiporeceData.CDNSUHOSTTEF||null) );
        } else {
            window.returnIntegration(self.invalidIntegrationInstance());
        }
    };

    this.reversalIntegrationResult = function(resolve, javaResult){
        var integrationResult = self.formatResponde();

        if (javaResult.statusCode == 1 || javaResult.statusCode == 3 ){
            integrationResult.error = false;
            resolve(integrationResult);
        } else {
            integrationResult.message = javaResult.message;
            resolve(integrationResult);
        }
    };

    this.completeIntegration = function(){
        return true;
    };

    this.completeIntegrationResult = function(resolve, javaResult){
        return true;
    };

    this.formatResponde = function(){
        return {
            error: true,
            message: '',
            data: {}
        };
    };

    this.invalidIntegrationInstance = function(){
        return {
            statusCode: '2',
            message: MESSAGE_INTEGRATION_FAIL
        };
    };

    this.handleJavaResult = function(javaResult){
        if(typeof(javaResult) === 'string'){
            javaResult = JSON.parse(javaResult);
        }
        return javaResult;
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('IntegrationSafraPay', IntegrationSafraPay);
});